Subject: Re: [PATCH net-next-2.6] netfilter: allow nf_tproxy_core module to be removed

From: KOVACS Krisztian <[email-masked]>
Date: Fri, 25 Jun 2010 09:56:57 +0200

Hi,

On 06/24/2010 05:29 PM, Patrick McHardy wrote:
> David Miller wrote:
>> From: Florian Westphal <[email-masked]>
>> Date: Wed, 23 Jun 2010 20:46:11 +0200
>>
>>> tproxy assigns skb->destructor, what prevents module unload while
>>> such skbs may
>>> still be around?
>>
>> The only reference to nf_tproxy_core.ko is for the symbol,
>> "nf_tproxy_assign_sock".
>> xt_TPROXY.c, which references this symbol, thus creates a symbol
>> dependency on this
>> module, so xt_TPROXY.o needs to unload before nf_tproxy_core.ko can
>> unload, and
>> xt_TPROXY.o has it's own manner for handling module references properly.
>
> I don't see anything waiting for skbs in flight using the tproxy
> destructor in either xt_TPROXY or nf_tproxy_core though, so I think
> Florian is correct.

Yes, I think Florian and Patrick's right. Right now there's nothing 
preventing xt_TPROXY and nf_tproxy_core from being removed while there 
are skbs in flight with the tproxy destructor set.

-- 
KOVACS Krisztian